-------------------------------------------------------------------------------
--! @file       reg1.vhd
--! @author     William Diehl
--! @brief      SCREAM reg1
--! @date       29 July 2016
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY reg1 IS
	PORT(
        D : IN STD_LOGIC;
        CLK   : IN STD_LOGIC;
		  INIT  : IN STD_LOGIC;
        EN    : IN STD_LOGIC;
	     Q     : OUT STD_LOGIC
        );
END reg1;

ARCHITECTURE behavioral OF reg1 IS
BEGIN
	PROCESS (CLK)
        BEGIN
            IF rising_edge(CLK) THEN
					IF (INIT = '1') THEN
						Q <= '0';
               ELSIF (EN = '1') THEN
                    Q <= D;
               END IF;
	    END IF;
        END PROCESS;
END behavioral;